      subroutine bdfr4w(r4arr,nelem1,nelem2,output,refnam,ident, &
                        chisqr,ndof,ierr)

      use dal
      use cp_head_mod

      implicit none

      integer, intent(IN) :: nelem1, nelem2, ierr, ndof      
      real(kind=single), dimension(nelem1,nelem2), intent(IN) :: r4arr
      real(kind=single), intent(IN) :: chisqr
      character(len=*), intent(IN) :: output, refnam, ident

      real(kind=single), dimension(:,:), pointer :: r4arr0

      integer :: ix, iy 
      integer, dimension(2) :: npix

      character(len=20) :: chistr
      
      type(DataSetT) :: set, set0
      Type(ArrayT) :: arr

      npix(1)  = nelem1
      npix(2)  = nelem2

      set = dataset(output, write)
      arr = addArray(set, "PRIMARY", Real32, npix)
      r4arr0 => real32array2data(arr)
      do ix=1,nelem1
        do iy=1,nelem2
          r4arr0(ix-1,iy-1)=r4arr(ix,iy)
        end do
      end do  
      set0 = dataset(refnam, read)
      call cp_head (set0, set, ident, 2)
      call setAttribute(arr,"CHISQR",chisqr, &
                       "Red. chi^2 of background spline fit")
      call setAttribute(arr,"NDOF",ndof, &
                       "Degrees of freedom of spline fit")

      call release(set0)
      call release(arr)
      call release(set)   

      return
      end
