module cp_head_mod

  use dal

  implicit none

contains

  !---------------------------------------------------------------------
  subroutine cp_attr (set1, set2, arr, attr)
  !---------------------------------------------------------------------

    type(DataSetT), intent(IN) :: set1, set2
    type(ArrayT), intent(IN) :: arr
    character(len=*), dimension(:), intent(IN) :: attr

    integer i

    do i=1,size(attr)
      if (hasAttribute(set1,attr(i))) then
        call setAttribute(set2,attribute(set1,attr(i)))
      else 
        if (hasAttribute(arr,attr(i))) then
          call setAttribute(set2,attribute(arr,attr(i)))
        end if
      end if
    end do

  end subroutine

  !---------------------------------------------------------------------
  subroutine cp_head (set1, set2, content, mod)
  !---------------------------------------------------------------------

    type(DataSetT), intent(IN) :: set1, set2
    type(ArrayT) :: arr
    character(len=*), intent (IN) :: content
    integer, intent(IN) :: mod

    arr = array (set1,"PRIMARY",read)

    if (mod > 0) then
      call cp_attr(set1,set2,arr,(/"INSTRUME","DETNAME "/) )
    end if

    if (mod == 2) then
      call cp_attr(set1,set2,arr,(/"BAND"/) )
    end if

    call cp_attr(set1,set2,arr, &
    (/ "TELESCOP","DATAMODE","FILTER  ","OBS_MODE","OBS_ID  ","EXP_ID  ", &
       "ORIGIN  ","OBJECT  ","RA_PNT  ","DEC_PNT ","ROLL_PNT", &
       "CRPIX1  ","CRPIX2  ","CRVAL1  ","CRVAL2  ","CDELT1  ", &
       "CDELT2  ","CTYPE1  ","CTYPE2  ","RADECSYS","EQUINOX ", &
       "EXPOSURE","DATE-OBS","DATE-END","OBSERVER"/) )

    call setAttribute(set2,"CONTENT", content, "Content of file")

    call release(arr)

  end subroutine cp_head

end module
